代码之家  ›  专栏  ›  技术社区  ›  Paolo Tedesco

检查Bash数组是否包含值

  •  328
  • Paolo Tedesco  · 技术社区  · 14 年前

    在Bash中,测试数组是否包含某个值的最简单方法是什么?

    32 回复  |  直到 4 年前
        1
  •  566
  •   Keegan    4 年前

    这种方法的优点是不需要在所有元素上循环(至少不显式)。但是自从 array_to_string_internal() array.c 仍然在数组元素上循环并将它们串联成一个字符串,这可能并不比提出的循环解决方案更有效,但更具可读性。

    if [[ " ${array[@]} " =~ " ${value} " ]]; then
        # whatever you want to do when array contains value
    fi
    
    if [[ ! " ${array[@]} " =~ " ${value} " ]]; then
        # whatever you want to do when array doesn't contain value
    fi
    

    array=("Jack Brown")
    value="Jack"
    

    正则表达式将看到“Jack”在数组中,即使它不是。因此您必须更改 IFS 如果你想继续使用这个解决方案,比如

    IFS=$'\t'
    array=("Jack Brown\tJack Smith")
    unset IFS
    value="Jack"
    
    if [[ "\t${array[@]}\t" =~ "\t${value}\t" ]]; then
        echo "true"
    else
        echo "false"
    fi
    

    这将打印“假”。

    显然,这也可以用作测试语句,允许将其表示为一个线性表达式

    [[ " ${array[@]} " =~ " ${value} " ]] && echo "true" || echo "false"
    
        2
  •  416
  •   dimo414    7 年前

    下面是实现这一点的一个小功能。搜索字符串是第一个参数,其余是数组元素:

    containsElement () {
      local e match="$1"
      shift
      for e; do [[ "$e" == "$match" ]] && return 0; done
      return 1
    }
    

    该函数的测试运行可能如下所示:

    $ array=("something to search for" "a string" "test2000")
    $ containsElement "a string" "${array[@]}"
    $ echo $?
    0
    $ containsElement "blaha" "${array[@]}"
    $ echo $?
    1
    
        3
  •  65
  •   Jellicle    4 年前

    单线解决方案

    printf '%s\n' "${myarray[@]}" | grep -P '^mypattern$'
    

    这个 printf 语句在单独的行上打印数组的每个元素。

    这个 grep 语句使用特殊字符 ^ $ 查找包含 确切地 给出的模式为 mypattern (不多不少)。


    用法

    if ... then 声明:

    if printf '%s\n' "${myarray[@]}" | grep -q -P '^mypattern$'; then
        # ...
    fi
    

    我加了一个 -q 格雷普 表达式,这样它就不会打印匹配项;它只会将匹配项的存在视为“true”

        4
  •  59
  •   ghostdog74    14 年前
    $ myarray=(one two three)
    $ case "${myarray[@]}" in  *"two"*) echo "found" ;; esac
    found
    
        5
  •  56
  •   Scott    14 年前
    for i in "${array[@]}"
    do
        if [ "$i" -eq "$yourValue" ] ; then
            echo "Found"
        fi
    done
    

    for i in "${array[@]}"
    do
        if [ "$i" == "$yourValue" ] ; then
            echo "Found"
        fi
    done
    
        6
  •  21
  •   LeoRochael    9 年前

    如果您需要性能,您不希望每次搜索时都在整个阵列上循环。

    在这种情况下,可以创建表示该数组索引的关联数组(哈希表或字典)。即,它将每个数组元素映射到其在数组中的索引中:

    make_index () {
      local index_name=$1
      shift
      local -a value_array=("$@")
      local i
      # -A means associative array, -g means create a global variable:
      declare -g -A ${index_name}
      for i in "${!value_array[@]}"; do
        eval ${index_name}["${value_array[$i]}"]=$i
      done
    }
    

    然后你可以这样使用它:

    myarray=('a a' 'b b' 'c c')
    make_index myarray_index "${myarray[@]}"
    

    像这样测试会员资格:

    member="b b"
    # the "|| echo NOT FOUND" below is needed if you're using "set -e"
    test "${myarray_index[$member]}" && echo FOUND || echo NOT FOUND
    

    或者:

    if [ "${myarray_index[$member]}" ]; then 
      echo FOUND
    fi
    

    另外,您还可以通过以下方式获得数组中值的索引:

    echo "<< ${myarray_index[$member]} >> is the index of $member"
    
        7
  •  17
  •   Sean DiSanti    10 年前

    inarray=$(echo ${haystack[@]} | grep -o "needle" | wc -w)
    

    非零值表示找到匹配项。

        8
  •  17
  •   Augusto Hack    5 年前

    另一个没有函数的线性函数:

    (for e in "${array[@]}"; do [[ "$e" == "searched_item" ]] && exit 0; done) && echo "found" || echo "not found"
    

    find_in_array() {
      local word=$1
      shift
      for e in "$@"; do [[ "$e" == "$word" ]] && return 0; done
      return 1
    }
    

    例子:

    some_words=( these are some words )
    find_in_array word "${some_words[@]}" || echo "expected missing! since words != word"
    
        9
  •  12
  •   Niko    12 年前
    containsElement () { for e in "${@:2}"; do [[ "$e" = "$1" ]] && return 0; done; return 1; }
    

        10
  •  9
  •   hornetbzz atiruz    14 年前

    以下是一个小贡献:

    array=(word "two words" words)  
    search_string="two"  
    match=$(echo "${array[@]:0}" | grep -o $search_string)  
    [[ ! -z $match ]] && echo "found !"  
    

    注:这种方式不区分“两个词”的大小写,但在问题中不需要这样做。

        11
  •  8
  •   Dennis Williamson    14 年前

    如果您想做一个快速而肮脏的测试,看看是否值得在整个数组上迭代以获得精确的匹配,Bash可以将数组视为标量。测试标量中的匹配项,如果没有匹配项,则跳过循环可以节省时间。很明显你会得到假阳性。

    array=(word "two words" words)
    if [[ ${array[@]} =~ words ]]
    then
        echo "Checking"
        for element in "${array[@]}"
        do
            if [[ $element == "words" ]]
            then
                echo "Match"
            fi
        done
    fi
    

    array=(word "two words" something) 它只会输出“Checking”。与 array=(word "two widgets" something) 不会有输出。

        12
  •  6
  •   Zombo tliff    9 年前
    a=(b c d)
    
    if printf '%s\0' "${a[@]}" | grep -Fqxz c
    then
      echo 'array “a” contains value “c”'
    fi
    

    如果您愿意,您可以使用等效的长选项:

    --fixed-strings --quiet --line-regexp --null-data
    
        13
  •  6
  •   Rosta Kosta    4 年前

    如何检查Bash数组是否包含值


    假阳性匹配

    array=(a1 b1 c1 d1 ee)
    
    [[ ${array[*]} =~ 'a' ]] && echo 'yes' || echo 'no'
    # output:
    yes
    
    [[ ${array[*]} =~ 'a1' ]] && echo 'yes' || echo 'no'
    # output:
    yes
    
    [[ ${array[*]} =~ 'e' ]] && echo 'yes' || echo 'no'
    # output:
    yes
    
    [[ ${array[*]} =~ 'ee' ]] && echo 'yes' || echo 'no'
    # output:
    yes
    

    为了寻找精确的匹配,您的正则表达式模式需要在值之前和之后添加额外的空间,如 (^|[[:space:]])"VALUE"($|[[:space:]])

    # Exact match
    
    array=(aa1 bc1 ac1 ed1 aee)
    
    if [[ ${array[*]} =~ (^|[[:space:]])"a"($|[[:space:]]) ]]; then
        echo "Yes";
    else
        echo "No";
    fi
    # output:
    No
    
    if [[ ${array[*]} =~ (^|[[:space:]])"ac1"($|[[:space:]]) ]]; then
        echo "Yes";
    else
        echo "No";
    fi
    # output:
    Yes
    
    find="ac1"
    if [[ ${array[*]} =~ (^|[[:space:]])"$find"($|[[:space:]]) ]]; then
        echo "Yes";
    else
        echo "No";
    fi
    # output:
    Yes
    

    here

        14
  •  5
  •   Chris Prince    8 年前

    这对我有用:

    # traditional system call return values-- used in an `if`, this will be true when returning 0. Very Odd.
    contains () {
        # odd syntax here for passing array parameters: http://stackoverflow.com/questions/8082947/how-to-pass-an-array-to-a-bash-function
        local list=$1[@]
        local elem=$2
    
        # echo "list" ${!list}
        # echo "elem" $elem
    
        for i in "${!list}"
        do
            # echo "Checking to see if" "$i" "is the same as" "${elem}"
            if [ "$i" == "${elem}" ] ; then
                # echo "$i" "was the same as" "${elem}"
                return 0
            fi
        done
    
        # echo "Could not find element"
        return 1
    }
    

    呼叫示例:

    arr=("abc" "xyz" "123")
    if contains arr "abcx"; then
        echo "Yes"
    else
        echo "No"
    fi
    
        15
  •  5
  •   Dejay Clayton    7 年前

    借款 Dennis Williamson answer

    declare -a array=('hello, stack' one 'two words' words last)
    printf -v array_str -- ',,%q' "${array[@]}"
    
    if [[ "${array_str},," =~ ,,words,, ]]
    then
       echo 'Matches'
    else
       echo "Doesn't match"
    fi
    

    1. 使用Bash的内置 printf %q . Shell引用将确保特殊字符通过反斜杠转义成为“Shell安全的” \ .
    2. 选择一个特殊字符作为值分隔符。分隔符必须是使用时将转义的特殊字符之一 ;这是确保数组中的值不能以巧妙的方式构造以欺骗正则表达式匹配的唯一方法。我选择逗号 , 因为这个字符在被评估或误用时是最安全的。
    3. 将所有数组元素组合成一个字符串,使用 用作分隔符的特殊字符的实例。以逗号为例,我使用 ,,%q 作为 打印F . 这一点很重要,因为只有当特殊字符的两个实例作为分隔符出现时,它们才能相邻出现;特殊字符的所有其他实例都将被转义。
    4. ${array_str} ,对照 ${array_str},, .
    5. 如果要搜索的目标字符串是由用户变量提供的,则 必须 用反斜杠转义特殊字符的所有实例。否则,正则表达式匹配就很容易被精心设计的数组元素所欺骗。
        16
  •  5
  •   Fonic    4 年前

    下面是几个可能实现的汇编,包括集成验证和简单的基准测试:

    #!/usr/bin/env bash
    
    # Check if array contains item [$1: item, $2: array name]
    function in_array_1() {
        local needle="$1" item
        local -n arrref="$2"
        for item in "${arrref[@]}"; do
            [[ "${item}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    # Check if array contains item [$1: item, $2: array name]
    function in_array_2() {
        local needle="$1" arrref="$2[@]" item
        for item in "${!arrref}"; do
            [[ "${item}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    # Check if array contains item [$1: item, $2: array name]
    function in_array_3() {
        local needle="$1" i
        local -n arrref="$2"
        for ((i=0; i < ${#arrref[@]}; i++)); do
            [[ "${arrref[i]}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    # Check if array contains item [$1: item, $2..$n: array items]
    function in_array_4() {
        local needle="$1" item
        shift
        for item; do
            [[ "${item}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    # Check if array contains item [$1: item, $2..$n: array items]
    function in_array_5() {
        local needle="$1" item
        for item in "${@:2}"; do
            [[ "${item}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    # Check if array contains item [$1: item, $2: array name]
    function in_array_6() {
        local needle="$1" arrref="$2[@]" array i
        array=("${!arrref}")
        for ((i=0; i < ${#array[@]}; i++)); do
            [[ "${array[i]}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    # Check if array contains item [$1: item, $2..$n: array items]
    function in_array_7() {
        local needle="$1" array=("${@:2}") item
        for item in "${array[@]}"; do
            [[ "${item}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    # Check if array contains item [$1: item, $2..$n: array items]
    function in_array_8() {
        local needle="$1"
        shift
        while (( $# > 0 )); do
            [[ "$1" == "${needle}" ]] && return 0
            shift
        done
        return 1
    }
    
    
    #------------------------------------------------------------------------------
    
    
    # Generate map for array [$1: name of source array, $2: name of target array]
    # NOTE: target array must be pre-declared by caller using 'declare -A <name>'
    function generate_array_map() {
        local -n srcarr="$1" dstmap="$2"
        local i key
        dstmap=()
        for i in "${!srcarr[@]}"; do
            key="${srcarr[i]}"
            [[ -z ${dstmap["${key}"]+set} ]] && dstmap["${key}"]=${i} || dstmap["${key}"]+=,${i}
        done
    }
    
    # Check if array contains item [$1: item, $2: name of array map]
    function in_array_9() {
        local needle="$1"
        local -n mapref="$2"
        [[ -n "${mapref["${needle}"]+set}" ]] && return 0 || return 1
    }
    
    
    #------------------------------------------------------------------------------
    
    
    # Test in_array function [$1: function name, $2: function description, $3: test array size]
    function test() {
        local tname="$1" tdesc="$2" tn=$3 ti=0 tj=0 ta=() tct=0 tepapre="" tepapost="" tepadiff=()
        local -A tam=()
    
        echo -e "\e[1m${tname} (${tdesc}):\e[0m"
    
        # Generate list of currently defined variables
        tepapre="$(compgen -v)"
    
        # Fill array with random items
        for ((ti=0; ti < ${tn}; ti++)); do
            ta+=("${RANDOM} ${RANDOM} ${RANDOM} ${RANDOM}")
        done
    
        # Determine function call type (pass array items, pass array name, pass array map)
        case "${tname}" in
            "in_array_1"|"in_array_2"|"in_array_3"|"in_array_6") tct=0; ;;
            "in_array_4"|"in_array_5"|"in_array_7"|"in_array_8") tct=1; ;;
            "in_array_9") generate_array_map ta tam; tct=2; ;;
            *) echo "Unknown in_array function '${tname}', aborting"; return 1; ;;
        esac
    
        # Verify in_array function is working as expected by picking a few random
        # items and checking
        echo -e "\e[1mVerification...\e[0m"
        for ((ti=0; ti < 10; ti++)); do
            tj=$(( ${RANDOM} % ${#ta[@]} ))
            echo -n "Item ${tj} '${ta[tj]}': "
            if (( ${tct} == 0 )); then
                "${tname}" "${ta[tj]}" ta && echo -en "\e[1;32mok\e[0m" || echo -en "\e[1;31mnok\e[0m"
                echo -n " "
                "${tname}" "${ta[tj]}.x" ta && echo -en "\e[1;31mnok\e[0m" || echo -en "\e[1;32mok\e[0m"
            elif (( ${tct} == 1 )); then
                "${tname}" "${ta[tj]}" "${ta[@]}" && echo -en "\e[1;32mok\e[0m" || echo -en "\e[1;31mnok\e[0m"
                echo -n " "
                "${tname}" "${ta[tj]}.x" "${ta[@]}" && echo -en "\e[1;31mnok\e[0m" || echo -en "\e[1;32mok\e[0m"
            elif (( ${tct} == 2 )); then
                "${tname}" "${ta[tj]}" tam && echo -en "\e[1;32mok\e[0m" || echo -en "\e[1;31mnok\e[0m"
                echo -n " "
                "${tname}" "${ta[tj]}.x" tam && echo -en "\e[1;31mnok\e[0m" || echo -en "\e[1;32mok\e[0m"
            fi
            echo
        done
    
        # Benchmark in_array function
        echo -en "\e[1mBenchmark...\e[0m"
        time for ((ti=0; ti < ${#ta[@]}; ti++)); do
            if (( ${tct} == 0 )); then
                "${tname}" "${ta[ti]}" ta
            elif (( ${tct} == 1 )); then
                "${tname}" "${ta[ti]}" "${ta[@]}"
            elif (( ${tct} == 2 )); then
                "${tname}" "${ta[ti]}" tam
            fi
        done
    
        # Generate list of currently defined variables, compare to previously
        # generated list to determine possible environment pollution
        echo -e "\e[1mEPA test...\e[0m"
        tepapost="$(compgen -v)"
        readarray -t tepadiff < <(echo -e "${tepapre}\n${tepapost}" | sort | uniq -u)
        if (( ${#tepadiff[@]} == 0 )); then
            echo -e "\e[1;32mclean\e[0m"
        else
            echo -e "\e[1;31mpolluted:\e[0m ${tepadiff[@]}"
        fi
    
        echo
    }
    
    
    #------------------------------------------------------------------------------
    
    
    # Test in_array functions
    n=5000
    echo
    ( test in_array_1 "pass array name, nameref reference, for-each-loop over array items" ${n} )
    ( test in_array_2 "pass array name, indirect reference, for-each-loop over array items" ${n} )
    ( test in_array_3 "pass array name, nameref reference, c-style for-loop over array items by index" ${n} )
    ( test in_array_4 "pass array items, for-each-loop over arguments" ${n} )
    ( test in_array_5 "pass array items, for-each-loop over arguments as array" ${n} )
    ( test in_array_6 "pass array name, indirect reference + array copy, c-style for-loop over array items by index" ${n} )
    ( test in_array_7 "pass array items, copy array from arguments as array, for-each-loop over array items" ${n} )
    ( test in_array_8 "pass array items, while-loop, shift over arguments" ${n} )
    ( test in_array_9 "pre-generated array map, pass array map name, direct test without loop" ${n} )
    

    结果:

    in_array_1 (pass array name, nameref reference, for-each-loop over array items):
    Verification...
    Item 862 '19528 10140 12669 17820': ok ok
    Item 2250 '27262 30442 9295 24867': ok ok
    Item 4794 '3857 17404 31925 27993': ok ok
    Item 2532 '14553 12282 26511 32657': ok ok
    Item 1911 '21715 8066 15277 27126': ok ok
    Item 4289 '3081 10265 16686 19121': ok ok
    Item 4837 '32220 1758 304 7871': ok ok
    Item 901 '20652 23880 20634 14286': ok ok
    Item 2488 '14578 8625 30251 9343': ok ok
    Item 4165 '4514 25064 29301 7400': ok ok
    Benchmark...
    real    1m11,796s
    user    1m11,262s
    sys     0m0,473s
    EPA test...
    clean
    
    in_array_2 (pass array name, indirect reference, for-each-loop over array items):
    Verification...
    Item 2933 '17482 25789 27710 2096': ok ok
    Item 3584 '876 14586 20885 8567': ok ok
    Item 872 '176 19749 27265 18038': ok ok
    Item 595 '6597 31710 13266 8813': ok ok
    Item 748 '569 9200 28914 11297': ok ok
    Item 3791 '26477 13218 30172 31532': ok ok
    Item 2900 '3059 8457 4879 16634': ok ok
    Item 676 '23511 686 589 7265': ok ok
    Item 2248 '31351 7961 17946 24782': ok ok
    Item 511 '8484 23162 11050 426': ok ok
    Benchmark...
    real    1m11,524s
    user    1m11,086s
    sys     0m0,437s
    EPA test...
    clean
    
    in_array_3 (pass array name, nameref reference, c-style for-loop over array items by index):
    Verification...
    Item 1589 '747 10250 20133 29230': ok ok
    Item 488 '12827 18892 31996 1977': ok ok
    Item 801 '19439 25243 24485 24435': ok ok
    Item 2588 '17193 18893 21610 9302': ok ok
    Item 4436 '7100 655 8847 3068': ok ok
    Item 2620 '19444 6457 28835 24717': ok ok
    Item 4398 '4420 16336 612 4255': ok ok
    Item 2430 '32397 2402 12631 29774': ok ok
    Item 3419 '906 5361 32752 7698': ok ok
    Item 356 '9776 16485 20838 13330': ok ok
    Benchmark...
    real    1m17,037s
    user    1m17,019s
    sys     0m0,005s
    EPA test...
    clean
    
    in_array_4 (pass array items, for-each-loop over arguments):
    Verification...
    Item 1388 '7932 15114 4025 15625': ok ok
    Item 3900 '23863 25328 5632 2752': ok ok
    Item 2678 '31296 4216 17485 8874': ok ok
    Item 1893 '16952 29047 29104 23384': ok ok
    Item 1616 '19543 5999 4485 22929': ok ok
    Item 93 '14456 2806 12829 19552': ok ok
    Item 265 '30961 19733 11863 3101': ok ok
    Item 4615 '10431 9566 25767 13518': ok ok
    Item 576 '11726 15104 11116 74': ok ok
    Item 3829 '19371 25026 6252 29478': ok ok
    Benchmark...
    real    1m30,912s
    user    1m30,740s
    sys     0m0,011s
    EPA test...
    clean
    
    in_array_5 (pass array items, for-each-loop over arguments as array):
    Verification...
    Item 1012 '29213 31971 21483 30225': ok ok
    Item 2802 '4079 5423 29240 29619': ok ok
    Item 473 '6968 798 23936 6852': ok ok
    Item 2183 '20734 4521 30800 2126': ok ok
    Item 3059 '14952 9918 15695 19309': ok ok
    Item 1424 '25784 28380 14555 21893': ok ok
    Item 1087 '16345 19823 26210 20083': ok ok
    Item 257 '28890 5198 7251 3866': ok ok
    Item 3986 '29035 19288 12107 3857': ok ok
    Item 2509 '9219 32484 12842 27472': ok ok
    Benchmark...
    real    1m53,485s
    user    1m53,404s
    sys     0m0,077s
    EPA test...
    clean
    
    in_array_6 (pass array name, indirect reference + array copy, c-style for-loop over array items by index):
    Verification...
    Item 4691 '25498 10521 20673 14948': ok ok
    Item 263 '25265 29824 3876 14088': ok ok
    Item 2550 '2416 14274 12594 29740': ok ok
    Item 2269 '2769 11436 3622 28273': ok ok
    Item 3246 '23730 25956 3514 17626': ok ok
    Item 1059 '10776 12514 27222 15640': ok ok
    Item 53 '23813 13365 16022 4092': ok ok
    Item 1503 '6593 23540 10256 17818': ok ok
    Item 2452 '12600 27404 30960 26759': ok ok
    Item 2526 '21190 32512 23651 7865': ok ok
    Benchmark...
    real    1m54,793s
    user    1m54,326s
    sys     0m0,457s
    EPA test...
    clean
    
    in_array_7 (pass array items, copy array from arguments as array, for-each-loop over array items):
    Verification...
    Item 2212 '12127 12828 27570 7051': ok ok
    Item 1393 '19552 26263 1067 23332': ok ok
    Item 506 '18818 8253 14924 30710': ok ok
    Item 789 '9803 1886 17584 32686': ok ok
    Item 1795 '19788 27842 28044 3436': ok ok
    Item 376 '4372 16953 17280 4031': ok ok
    Item 4846 '19130 6261 21959 6869': ok ok
    Item 2064 '2357 32221 22682 5814': ok ok
    Item 4866 '10928 10632 19175 14984': ok ok
    Item 1294 '8499 11885 5900 6765': ok ok
    Benchmark...
    real    2m35,012s
    user    2m33,578s
    sys     0m1,433s
    EPA test...
    clean
    
    in_array_8 (pass array items, while-loop, shift over arguments):
    Verification...
    Item 134 '1418 24798 20169 9501': ok ok
    Item 3986 '12160 12021 29794 29236': ok ok
    Item 1607 '26633 14260 18227 898': ok ok
    Item 2688 '18387 6285 2385 18432': ok ok
    Item 603 '1421 306 6102 28735': ok ok
    Item 625 '4530 19718 30900 1938': ok ok
    Item 4033 '9968 24093 25080 8179': ok ok
    Item 310 '6867 9884 31231 29173': ok ok
    Item 661 '3794 4745 26066 22691': ok ok
    Item 4129 '3039 31766 6714 4921': ok ok
    Benchmark...
    real    5m51,097s
    user    5m50,566s
    sys     0m0,495s
    EPA test...
    clean
    
    in_array_9 (pre-generated array map, pass array map name, direct test without loop):
    Verification...
    Item 3696 '661 6048 13881 26901': ok ok
    Item 815 '29729 13733 3935 20697': ok ok
    Item 1076 '9220 3405 18448 7240': ok ok
    Item 595 '8912 2886 13678 24066': ok ok
    Item 2803 '13534 23891 5344 652': ok ok
    Item 1810 '12528 32150 7050 1254': ok ok
    Item 4055 '21840 7436 1350 15443': ok ok
    Item 2416 '19550 28434 17110 31203': ok ok
    Item 1630 '21054 2819 7527 953': ok ok
    Item 1044 '30152 22211 22226 6950': ok ok
    Benchmark...
    real    0m0,128s
    user    0m0,128s
    sys     0m0,000s
    EPA test...
    clean
    
        17
  •  4
  •   Sergey Ushakov    5 年前

    if ( dlm=$'\x1F' ; IFS="$dlm" ; [[ "$dlm${array[*]}$dlm" == *"$dlm${item}$dlm"* ]] ) ; then
      echo "array contains '$item'"
    else
      echo "array does not contain '$item'"
    fi
    

    这种方法既不使用像 grep

    这里发生的是:

    • 为了安全起见,我们使用不可打印字符作为分隔符;
    • 通过临时替换 IFS
    • 我们做这个 如果 通过在子shell(在一对圆括号内)中计算条件表达式来临时替换值
        18
  •  4
  •   kvantour    4 年前

    The answer with most votes "${array[*]}" 而不是 "${array[@]}" . 方法是相同的,但看起来不太干净。通过使用 ,我们打印 $array IFS . 所以选择一个正确的 ,您可以克服这个特殊问题。在这种情况下,我们决定 如果 $'\001' 代表什么 航向起点 ( SOH )

    $ array=("foo bar" "baz" "qux")
    $ IFS=$'\001'
    $ [[ "$IFS${array[*]}$IFS" =~ "${IFS}foo${IFS}" ]] && echo yes || echo no
    no
    $ [[ "$IFS${array[*]}$IFS" =~ "${IFS}foo bar${IFS}" ]] && echo yes || echo no
    yes
    $ unset IFS
    

    如果 .

    如果 如果 以前设置过,最好保存并重置它,而不是使用 unset IFS


    相关:

        19
  •  3
  •   Aleksandr Podkutin    6 年前

    对@ghostdog74关于使用 case 检查数组是否包含特定值的逻辑:

    myarray=(one two three)
    word=two
    case "${myarray[@]}" in  ("$word "*|*" $word "*|*" $word") echo "found" ;; esac
    

    或与 extglob 选项打开时,您可以这样做:

    myarray=(one two three)
    word=two
    shopt -s extglob
    case "${myarray[@]}" in ?(*" ")"$word"?(" "*)) echo "found" ;; esac
    

    我们也可以用 if 声明:

    myarray=(one two three)
    word=two
    if [[ $(printf "_[%s]_" "${myarray[@]}") =~ .*_\[$word\]_.* ]]; then echo "found"; fi
    
        20
  •  3
  •   Cwista    4 年前

    精确的单词匹配

    find="myword"
    array=(value1 value2 myword)
    if [[ ! -z $(printf '%s\n' "${array[@]}" | grep -w $find) ]]; then
      echo "Array contains myword";
    fi
    

    word val ,只有全字匹配。如果每个数组值包含多个单词,它将中断。

        21
  •  2
  •   Beorn Harris    11 年前

    鉴于:

    array=("something to search for" "a string" "test2000")
    elem="a string"
    

    然后简单检查:

    if c=$'\x1E' && p="${c}${elem} ${c}" && [[ ! "${array[@]/#/${c}} ${c}" =~ $p ]]; then
      echo "$elem exists in array"
    fi
    

    哪里

    c is element separator
    p is regex pattern
    

    (单独指定p而不是直接在[[]中使用表达式的原因是为了保持bash4的兼容性)

        22
  •  2
  •   Qwerty    8 年前

    使用 grep printf

    在新行上格式化每个数组成员,然后 排队。

    if printf '%s\n' "${array[@]}" | grep -x -q "search string"; then echo true; else echo false; fi
    
    $ array=("word", "two words")
    $ if printf '%s\n' "${array[@]}" | grep -x -q "two words"; then echo true; else echo false; fi
    true
    

    请注意,这与delimeters和space没有问题。

        23
  •  1
  •   Barry Kelly    11 年前

    以下是使用数组名称的版本:

    function array_contains # array value
    {
        [[ -n "$1" && -n "$2" ]] || {
            echo "usage: array_contains <array> <value>"
            echo "Returns 0 if array contains value, 1 otherwise"
            return 2
        }
    
        eval 'local values=("${'$1'[@]}")'
    
        local element
        for element in "${values[@]}"; do
            [[ "$element" == "$2" ]] && return 0
        done
        return 1
    }
    

    array_contains A "one" && echo "contains one"
    

    等。

        24
  •  1
  •   Gabriel Laden    4 年前

    使用参数展开:

    ${parameter:+word}如果参数为null或未设置,则不显示任何内容 替换,否则将替换单词的扩展。

    declare -A myarray
    myarray[hello]="world"
    
    for i in hello goodbye 123
    do
      if [ ${myarray[$i]:+_} ]
      then
        echo ${!myarray[$i]} ${myarray[$i]} 
      else
        printf "there is no %s\n" $i
      fi
    done
    
        25
  •  0
  •   Qwerty    8 年前

    array=("word" "two words") # let's look for "two words"
    

    使用 grep printf :

    (printf '%s\n' "${array[@]}" | grep -x -q "two words") && <run_your_if_found_command_here>
    

    for :

    (for e in "${array[@]}"; do [[ "$e" == "two words" ]] && exit 0; done; exit 1) && <run_your_if_found_command_here>
    

    || <run_your_if_notfound_command_here>

        26
  •  0
  •   ghoti    8 年前

    这是我的看法。

    function array_contains { # arrayname value
      local -A _arr=()
      local IFS=
      eval _arr=( $(eval printf '[%q]="1"\ ' "\${$1[@]}") )
      return $(( 1 - 0${_arr[$2]} ))
    }
    

    _arr ,其索引是从输入数组的值派生的。(请注意,bash4及更高版本中提供了关联数组,因此此函数在bash的早期版本中不起作用) $IFS 避免在空白处分词。

    printf %q 确保对输入数据进行转义,以便将其安全地用作数组键。

    $ a=("one two" three four)
    $ array_contains a three && echo BOOYA
    BOOYA
    $ array_contains a two && echo FAIL
    $
    

    请注意,此函数使用的所有内容都是bash的内置内容,因此即使在命令扩展中,也没有外部管道将您拖下水。

    eval ... 好吧,你可以自由使用另一种方法。:-)

        27
  •  0
  •   Charles Duffy    4 年前

    行动计划本身添加了以下答案,并附有评注:

    在回答和评论的帮助下,经过一些测试,我得出了以下结论:

    function contains() {
        local n=$#
        local value=${!n}
        for ((i=1;i < $#;i++)) {
            if [ "${!i}" == "${value}" ]; then
                echo "y"
                return 0
            fi
        }
        echo "n"
        return 1
    }
    
    A=("one" "two" "three four")
    if [ $(contains "${A[@]}" "one") == "y" ]; then
        echo "contains one"
    fi
    if [ $(contains "${A[@]}" "three") == "y" ]; then
        echo "contains three"
    fi
    
        28
  •  0
  •   Mahmoud Odeh    4 年前

    保持简单:

    Array1=( "item1" "item2" "item3" "item-4" )
    var="item3"
    
    count=$(echo ${Array1[@]} | tr ' ' '\n' | awk '$1 == "'"$var"'"{print $0}' | wc -l)
    [ $count -eq 0 ] && echo "Not found" || echo "found"
    
        29
  •  0
  •   Tino    4 年前
    : NeedleInArgs "$needle" "${haystack[@]}"
    : NeedleInArgs "$needle" arg1 arg2 .. argN
    NeedleInArgs()
    {
    local a b;
    printf -va '\n%q\n' "$1";
    printf -vb '%q\n' "${@:2}";
    case $'\n'"$b" in (*"$a"*) return 0;; esac;
    return 1;
    }
    

    像这样使用:

    NeedleInArgs "$needle" "${haystack[@]}" && echo "$needle" found || echo "$needle" not found;
    
    • bash v3.1及以上版本( printf -v (支撑)
    • )

    也可直接用于:

    if      NeedleInArgs "$input" value1 value2 value3 value4;
    then
            : input from the list;
    else
            : input not from list;
    fi;
    

    为了 猛击 从v2.05b到v3.0 printf 缺乏 -v 因此,这需要2个额外的fork(但没有exec,如图所示) 猛击 内置):

    NeedleInArgs()
    {
    case $'\n'"`printf '%q\n' "${@:2}"`" in
    (*"`printf '\n%q\n' "$1"`"*) return 0;;
    esac;
    return 1;
    }
    

    check call0:  n: t4.43 u4.41 s0.00 f: t3.65 u3.64 s0.00 l: t4.91 u4.90 s0.00 N: t5.28 u5.27 s0.00 F: t2.38 u2.38 s0.00 L: t5.20 u5.20 s0.00
    check call1:  n: t3.41 u3.40 s0.00 f: t2.86 u2.84 s0.01 l: t3.72 u3.69 s0.02 N: t4.01 u4.00 s0.00 F: t1.15 u1.15 s0.00 L: t4.05 u4.05 s0.00
    check call2:  n: t3.52 u3.50 s0.01 f: t3.74 u3.73 s0.00 l: t3.82 u3.80 s0.01 N: t2.67 u2.67 s0.00 F: t2.64 u2.64 s0.00 L: t2.68 u2.68 s0.00
    
    • call0 call1 调用另一个快速纯bash变体的不同变体
    • call2 这是这儿吗。
    • N =未找到 F L =上次匹配
    • 小写字母是短数组,大写字母是长数组

    但非常重要的是,搜索变体的效率更高,因为这里的变体总是将整个数组转换为一个大字符串。

    in_array()
    {
        local needle="$1" arrref="$2[@]" item
        for item in "${!arrref}"; do
            [[ "${item}" == "${needle}" ]] && return 0
        done
        return 1
    }
    
    NeedleInArgs()
    {
    local a b;
    printf -va '\n%q\n' "$1";
    printf -vb '%q\n' "${@:2}";
    case $'\n'"$b" in (*"$a"*) return 0;; esac;
    return 1;
    }
    
    loop1() { for a in {1..100000}; do "$@"; done }
    loop2() { for a in {1..1000}; do "$@"; done }
    
    run()
    {
      needle="$5"
      arr=("${@:6}")
    
      out="$( ( time -p "loop$2" "$3" ) 2>&1 )"
    
      ret="$?"
      got="${out}"
      syst="${got##*sys }"
      got="${got%"sys $syst"}"
      got="${got%$'\n'}"
      user="${got##*user }"
      got="${got%"user $user"}"
      got="${got%$'\n'}"
      real="${got##*real }"
      got="${got%"real $real"}"
      got="${got%$'\n'}"
      printf ' %s: t%q u%q s%q' "$1" "$real" "$user" "$syst"
      [ -z "$rest" ] && [ "$ret" = "$4" ] && return
      printf 'FAIL! expected %q got %q\n' "$4" "$ret"
      printf 'call:   %q\n' "$3"
      printf 'out:    %q\n' "$out"
      printf 'rest:   %q\n' "$rest"
      printf 'needle: %q\n' "$5"
      printf 'arr:   '; printf ' %q' "${@:6}"; printf '\n'
      exit 1
    }
    
    check()
    {
      printf 'check %q: ' "$1"
      run n 1 "$1" 1 needle a b c d
      run f 1 "$1" 0 needle needle a b c d
      run l 1 "$1" 0 needle a b c d needle
      run N 2 "$1" 1 needle "${rnd[@]}"
      run F 2 "$1" 0 needle needle "${rnd[@]}"
      run L 2 "$1" 0 needle "${rnd[@]}" needle
      printf '\n'
    }
    
    call0() { chk=("${arr[@]}"); in_array "$needle" chk; }
    call1() { in_array "$needle" arr; }
    call2() { NeedleInArgs "$needle" "${arr[@]}"; }
    
    rnd=()
    for a in {1..1000}; do rnd+=("$a"); done
    
    check call0
    check call1
    check call2
    
        30
  •  -1
  •   jmpp    9 年前

    我已经提出的正则表达式技术版本:

    values=(foo bar)
    requestedValue=bar
    
    requestedValue=${requestedValue##[[:space:]]}
    requestedValue=${requestedValue%%[[:space:]]}
    [[ "${values[@]/#/X-}" =~ "X-${requestedValue}" ]] || echo "Unsupported value"
    

    我相信它是干净而优雅的,尽管我不太确定如果支持的值数组特别大,它的性能会如何。